---   # Tasks specific to Galera clusters

- name: Install Galera
  apt:
    name:
      - galera-3
    state: present

- name: Write galera configuration to config file
  ini_file:
    path: /etc/mysql/mariadb.conf.d/90-galera.cnf
    section: "{{ item.section }}"
    option: "{{ item.option }}"
    value: "{{ item.value }}"
    no_extra_spaces: true
    create: true
  loop:
    - section: mysqld
      option: binlog_format
      value: ROW
    - section: mysqld
      option: default_storage_engine
      value: innodb
    - section: mysqld
      option: innodb_autoinc_lock_mode
      value: 2
    - section: mysqld
      option: innodb_doublewrite
      value: 1
    - section: mysqld
      option: bind_address
      value: 0.0.0.0
    - section: mysqld
      option: innodb_flush_log_at_trx_commit
      value: 0
    - section: galera
      option: wsrep_cluster_name
      value: "{{ mariadb_server_cluster_name }}"
    - section: galera
      option: wsrep_cluster_address
      value: "gcomm://{{ mariadb_server_cluster_nodes | join(',') }}"
    # - section: galera
    #   option: wsrep_debug
    #   value: 'ON'
    - section: galera
      option: wsrep_node_name
      value: "{{ ansible_hostname }}"
    - section: galera
      option: wsrep_node_address
      value: "{{ ansible_default_ipv4.address }}"
    - section: galera
      option: wsrep_on
      value: 'ON'
    - section: galera
      option: wsrep_provider
      value: /usr/lib/galera/libgalera_smm.so
    - section: galera
      option: wsrep_provider_options
      value: "gcache.size=512M"
    # - section: galera
    #   option: wsrep_sst_method
    #   value: mariabackup
    #   state: absent
    # - section: galera
    #   option: wsrep_sst_auth
    #   value: "{{ mariadb_server_backup_user }}:{{ mariadb_server_backup_password }}"
    #   state: absent
    - section: mariabackup
      option: user
      value: "{{ mariadb_server_backup_user }}"
    - section: mariabackup
      option: password
      value: "{{ mariadb_server_backup_password }}"
  register: configfile_create

- name: Init the cluster on first node
  shell: systemctl stop mariadb && galera_new_cluster && touch "{{ flagfile }}"
  args:
    creates: "{{ flagfile }}"
  vars:
    flagfile: /var/lib/mysql/galera_cluster_initiated.flag
  when: ansible_nodename == mariadb_server_cluster_nodes|first

- name: Restart cluster nodes other than the first one
  service:
    name: mariadb
    state: restarted
  when: (ansible_nodename != mariadb_server_cluster_nodes|first) and configfile_create.changed
